/*
    CHAMELEON File Encryption
    Copyright (C) 2000	Ulli Meybohm, www.meybohm.de (ulli@meybohm.de)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef CHAMELEON_H
#define CHAMELEON_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define ENCODINGMODE 1
#define DECODINGMODE 0


/* CHAMELEON CORE API ---------------------------------*/


typedef struct chameleon_data {
	unsigned char *key;
	unsigned char keyindex;
	unsigned char modifier;
	int mode;
} chameleon_t;

chameleon_t * chameleon_init(char * password, int mode);
char chameleon_char(chameleon_t *c, char src);
void chameleon_free(chameleon_t *c);

/*void chameleon_buffer(chameleon_t *c, char* dest_buffer, char* src_buffer, int size);*/




/* ALTERNATIVE API 2 : Encode Streams-------------------
	input  = Input Stream
	output = Output Stream
	mode = 1 for encodeing and 0 for decoding */

void chameleon_stream
	(FILE * inputstream , FILE * outputstream, char * password, int mode);




/* PARANOID API 3: Encode Streams with dummy headers (like used in cenc) */

void chameleon_dh_stream
	(FILE * inputstream , FILE * outputstream, char * password, int mode,
	int headersize, char * randominit);





#endif
